package cn.com.yitong.ares.jstl.lang.parser;

import cn.com.yitong.ares.jstl.lang.AndOperator;
import cn.com.yitong.ares.jstl.lang.ArraySuffix;
import cn.com.yitong.ares.jstl.lang.BinaryOperatorExpression;
import cn.com.yitong.ares.jstl.lang.BooleanLiteral;
import cn.com.yitong.ares.jstl.lang.ComplexValue;
import cn.com.yitong.ares.jstl.lang.DivideOperator;
import cn.com.yitong.ares.jstl.lang.EmptyOperator;
import cn.com.yitong.ares.jstl.lang.EqualsOperator;
import cn.com.yitong.ares.jstl.lang.Expression;
import cn.com.yitong.ares.jstl.lang.ExpressionString;
import cn.com.yitong.ares.jstl.lang.FloatingPointLiteral;
import cn.com.yitong.ares.jstl.lang.FunctionInvocation;
import cn.com.yitong.ares.jstl.lang.GreaterThanOperator;
import cn.com.yitong.ares.jstl.lang.GreaterThanOrEqualsOperator;
import cn.com.yitong.ares.jstl.lang.IntegerLiteral;
import cn.com.yitong.ares.jstl.lang.LessThanOperator;
import cn.com.yitong.ares.jstl.lang.LessThanOrEqualsOperator;
import cn.com.yitong.ares.jstl.lang.Literal;
import cn.com.yitong.ares.jstl.lang.MinusOperator;
import cn.com.yitong.ares.jstl.lang.ModulusOperator;
import cn.com.yitong.ares.jstl.lang.MultiplyOperator;
import cn.com.yitong.ares.jstl.lang.NamedValue;
import cn.com.yitong.ares.jstl.lang.NotEqualsOperator;
import cn.com.yitong.ares.jstl.lang.NotOperator;
import cn.com.yitong.ares.jstl.lang.NullLiteral;
import cn.com.yitong.ares.jstl.lang.OrOperator;
import cn.com.yitong.ares.jstl.lang.PlusOperator;
import cn.com.yitong.ares.jstl.lang.PropertySuffix;
import cn.com.yitong.ares.jstl.lang.StringLiteral;
import cn.com.yitong.ares.jstl.lang.UnaryMinusOperator;
import cn.com.yitong.ares.jstl.lang.UnaryOperator;
import cn.com.yitong.ares.jstl.lang.UnaryOperatorExpression;
import cn.com.yitong.ares.jstl.lang.ValueSuffix;
import cn.com.yitong.ares.jstl.lang.parser.ELParserConstants;
import cn.com.yitong.ares.jstl.lang.parser.ELParserTokenManager;
import cn.com.yitong.ares.jstl.lang.parser.ParseException;
import cn.com.yitong.ares.jstl.lang.parser.SimpleCharStream;
import cn.com.yitong.ares.jstl.lang.parser.Token;
import java.io.InputStream;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Vector;

public class ELParser implements ELParserConstants {

   public ELParserTokenManager token_source;
   private SimpleCharStream a;
   public Token token;
   public Token jj_nt;
   private int t;
   private Token a;
   private Token b;
   private int u;
   public boolean lookingAhead = false;
   private int v;
   private final int[] b = new int[34];
   private final int[] c = new int[]{6, 6, 6, 0, 0, 0, 0, 408944640, 6291456, 402653184, 408944640, 127795200, 1572864, 393216, 100663296, 25165824, 127795200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 536900992, 0, Integer.MIN_VALUE, 536900992, 65536, 30080, 12288};
   private final int[] d = new int[]{0, 0, 0, '쀀', '쀀', 12288, 12288, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 992, 192, 768, 992, 68624, 3072, 68624, 2, 0, 131072, 0, 199696, 2, 0, 0};
   private final ELParser.a[] a = new ELParser.a[2];
   private boolean g = false;
   private int w = 0;
   private Vector a = new Vector();
   private int[] e;
   private int x = -1;
   private int[] f = new int[100];
   private int y;


   public static void main(String[] args) throws ParseException {
      (new ELParser(System.in)).ExpressionString();
   }

   public final Object ExpressionString() throws ParseException {
      ArrayList elems = null;
      Object ret;
      switch(this.t == -1?this.a():this.t) {
      case 1:
         ret = this.AttrValueString();
         break;
      case 2:
         ret = this.AttrValueExpression();
         break;
      default:
         this.b[0] = this.v;
         this.a(-1);
         throw new ParseException();
      }

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 1:
         case 2:
            Object elem;
            switch(this.t == -1?this.a():this.t) {
            case 1:
               elem = this.AttrValueString();
               break;
            case 2:
               elem = this.AttrValueExpression();
               break;
            default:
               this.b[2] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            if(elems == null) {
               (elems = new ArrayList()).add(ret);
            }

            elems.add(elem);
            break;
         default:
            this.b[1] = this.v;
            if(elems != null) {
               ret = new ExpressionString(elems.toArray());
            }

            return ret;
         }
      }
   }

   public final String AttrValueString() throws ParseException {
      return this.a(1).image;
   }

   public final Expression AttrValueExpression() throws ParseException {
      this.a(2);
      Expression exp = this.Expression();
      this.a(15);
      return exp;
   }

   public final Expression Expression() throws ParseException {
      return this.OrExpression();
   }

   public final Expression OrExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.AndExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 46:
         case 47:
            switch(this.t == -1?this.a():this.t) {
            case 46:
               this.a(46);
               break;
            case 47:
               this.a(47);
               break;
            default:
               this.b[4] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            OrOperator operator = OrOperator.SINGLETON;
            Expression expression = this.AndExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         default:
            this.b[3] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression AndExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.EqualityExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 44:
         case 45:
            switch(this.t == -1?this.a():this.t) {
            case 44:
               this.a(44);
               break;
            case 45:
               this.a(45);
               break;
            default:
               this.b[6] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            AndOperator operator = AndOperator.SINGLETON;
            Expression expression = this.EqualityExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         default:
            this.b[5] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression EqualityExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.RelationalExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 21:
         case 22:
         case 27:
         case 28:
            Object operator;
            switch(this.t == -1?this.a():this.t) {
            case 21:
            case 22:
               switch(this.t == -1?this.a():this.t) {
               case 21:
                  this.a(21);
                  break;
               case 22:
                  this.a(22);
                  break;
               default:
                  this.b[8] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = EqualsOperator.SINGLETON;
               break;
            case 23:
            case 24:
            case 25:
            case 26:
            default:
               this.b[10] = this.v;
               this.a(-1);
               throw new ParseException();
            case 27:
            case 28:
               switch(this.t == -1?this.a():this.t) {
               case 27:
                  this.a(27);
                  break;
               case 28:
                  this.a(28);
                  break;
               default:
                  this.b[9] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = NotEqualsOperator.SINGLETON;
            }

            Expression expression = this.RelationalExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         case 23:
         case 24:
         case 25:
         case 26:
         default:
            this.b[7] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression RelationalExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.AddExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 17:
         case 18:
         case 19:
         case 20:
         case 23:
         case 24:
         case 25:
         case 26:
            Object operator;
            switch(this.t == -1?this.a():this.t) {
            case 17:
            case 18:
               switch(this.t == -1?this.a():this.t) {
               case 17:
                  this.a(17);
                  break;
               case 18:
                  this.a(18);
                  break;
               default:
                  this.b[13] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = GreaterThanOperator.SINGLETON;
               break;
            case 19:
            case 20:
               switch(this.t == -1?this.a():this.t) {
               case 19:
                  this.a(19);
                  break;
               case 20:
                  this.a(20);
                  break;
               default:
                  this.b[12] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = LessThanOperator.SINGLETON;
               break;
            case 21:
            case 22:
            default:
               this.b[16] = this.v;
               this.a(-1);
               throw new ParseException();
            case 23:
            case 24:
               switch(this.t == -1?this.a():this.t) {
               case 23:
                  this.a(23);
                  break;
               case 24:
                  this.a(24);
                  break;
               default:
                  this.b[15] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = LessThanOrEqualsOperator.SINGLETON;
               break;
            case 25:
            case 26:
               switch(this.t == -1?this.a():this.t) {
               case 25:
                  this.a(25);
                  break;
               case 26:
                  this.a(26);
                  break;
               default:
                  this.b[14] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = GreaterThanOrEqualsOperator.SINGLETON;
            }

            Expression expression = this.AddExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         case 21:
         case 22:
         default:
            this.b[11] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression AddExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.MultiplyExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 35:
         case 36:
            Object operator;
            switch(this.t == -1?this.a():this.t) {
            case 35:
               this.a(35);
               operator = PlusOperator.SINGLETON;
               break;
            case 36:
               this.a(36);
               operator = MinusOperator.SINGLETON;
               break;
            default:
               this.b[18] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            Expression expression = this.MultiplyExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         default:
            this.b[17] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression MultiplyExpression() throws ParseException {
      ArrayList operators = null;
      ArrayList expressions = null;
      Expression startExpression = this.UnaryExpression();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 37:
         case 38:
         case 39:
         case 40:
         case 41:
            Object operator;
            switch(this.t == -1?this.a():this.t) {
            case 37:
               this.a(37);
               operator = MultiplyOperator.SINGLETON;
               break;
            case 38:
            case 39:
               switch(this.t == -1?this.a():this.t) {
               case 38:
                  this.a(38);
                  break;
               case 39:
                  this.a(39);
                  break;
               default:
                  this.b[20] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = DivideOperator.SINGLETON;
               break;
            case 40:
            case 41:
               switch(this.t == -1?this.a():this.t) {
               case 40:
                  this.a(40);
                  break;
               case 41:
                  this.a(41);
                  break;
               default:
                  this.b[21] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = ModulusOperator.SINGLETON;
               break;
            default:
               this.b[22] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            Expression expression = this.UnaryExpression();
            if(operators == null) {
               operators = new ArrayList();
            }

            if(expressions == null) {
               expressions = new ArrayList();
            }

            operators.add(operator);
            expressions.add(expression);
            break;
         default:
            this.b[19] = this.v;
            if(operators != null) {
               return new BinaryOperatorExpression(startExpression, operators, expressions);
            }

            return startExpression;
         }
      }
   }

   public final Expression UnaryExpression() throws ParseException {
      Object singleOperator = null;
      ArrayList operators = null;

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 36:
         case 42:
         case 43:
         case 48:
            Object operator;
            switch(this.t == -1?this.a():this.t) {
            case 36:
               this.a(36);
               operator = UnaryMinusOperator.SINGLETON;
               break;
            case 42:
            case 43:
               switch(this.t == -1?this.a():this.t) {
               case 42:
                  this.a(42);
                  break;
               case 43:
                  this.a(43);
                  break;
               default:
                  this.b[24] = this.v;
                  this.a(-1);
                  throw new ParseException();
               }

               operator = NotOperator.SINGLETON;
               break;
            case 48:
               this.a(48);
               operator = EmptyOperator.SINGLETON;
               break;
            default:
               this.b[25] = this.v;
               this.a(-1);
               throw new ParseException();
            }

            if(singleOperator == null) {
               singleOperator = operator;
            } else if(operators == null) {
               (operators = new ArrayList()).add(singleOperator);
               operators.add(operator);
            } else {
               operators.add(operator);
            }
            break;
         default:
            this.b[23] = this.v;
            Expression expression = this.Value();
            if(operators != null) {
               return new UnaryOperatorExpression((UnaryOperator)null, operators, expression);
            }

            if(singleOperator != null) {
               return new UnaryOperatorExpression((UnaryOperator)singleOperator, (List)null, expression);
            }

            return expression;
         }
      }
   }

   public final Expression Value() throws ParseException {
      ArrayList suffixes = null;
      Expression prefix = this.ValuePrefix();

      while(true) {
         switch(this.t == -1?this.a():this.t) {
         case 16:
         case 33:
            ValueSuffix suffix = this.ValueSuffix();
            if(suffixes == null) {
               suffixes = new ArrayList();
            }

            suffixes.add(suffix);
            break;
         default:
            this.b[26] = this.v;
            if(suffixes == null) {
               return prefix;
            }

            return new ComplexValue(prefix, suffixes);
         }
      }
   }

   public final Expression ValuePrefix() throws ParseException {
      Object ret;
      switch(this.t == -1?this.a():this.t) {
      case 7:
      case 8:
      case 10:
      case 12:
      case 13:
      case 14:
         ret = this.Literal();
         break;
      case 9:
      case 11:
      case 15:
      case 16:
      case 17:
      case 18:
      case 19:
      case 20:
      case 21:
      case 22:
      case 23:
      case 24:
      case 25:
      case 26:
      case 27:
      case 28:
      default:
         this.b[27] = this.v;
         int var3 = Integer.MAX_VALUE;
         this.u = Integer.MAX_VALUE;
         this.b = this.a = this.token;
         boolean var4 = !this.d();
         this.b(0, Integer.MAX_VALUE);
         if(var4) {
            ret = this.FunctionInvocation();
            break;
         } else {
            switch(this.t == -1?this.a():this.t) {
            case 49:
               ret = this.NamedValue();
               return (Expression)ret;
            default:
               this.b[28] = this.v;
               this.a(-1);
               throw new ParseException();
            }
         }
      case 29:
         this.a(29);
         ret = this.Expression();
         this.a(30);
      }

      return (Expression)ret;
   }

   public final NamedValue NamedValue() throws ParseException {
      Token t = this.a(49);
      return new NamedValue(t.image);
   }

   public final FunctionInvocation FunctionInvocation() throws ParseException {
      String qualifiedName;
      ArrayList argumentList;
      argumentList = new ArrayList();
      qualifiedName = this.QualifiedName();
      this.a(29);
      label28:
      switch(this.t == -1?this.a():this.t) {
      case 7:
      case 8:
      case 10:
      case 12:
      case 13:
      case 14:
      case 29:
      case 36:
      case 42:
      case 43:
      case 48:
      case 49:
         Expression exp = this.Expression();
         argumentList.add(exp);

         while(true) {
            switch(this.t == -1?this.a():this.t) {
            case 31:
               this.a(31);
               exp = this.Expression();
               argumentList.add(exp);
               break;
            default:
               this.b[29] = this.v;
               break label28;
            }
         }
      case 9:
      case 11:
      case 15:
      case 16:
      case 17:
      case 18:
      case 19:
      case 20:
      case 21:
      case 22:
      case 23:
      case 24:
      case 25:
      case 26:
      case 27:
      case 28:
      case 30:
      case 31:
      case 32:
      case 33:
      case 34:
      case 35:
      case 37:
      case 38:
      case 39:
      case 40:
      case 41:
      case 44:
      case 45:
      case 46:
      case 47:
      default:
         this.b[30] = this.v;
      }

      this.a(30);
      return new FunctionInvocation(qualifiedName, argumentList);
   }

   public final ValueSuffix ValueSuffix() throws ParseException {
      Object suffix;
      switch(this.t == -1?this.a():this.t) {
      case 16:
         suffix = this.PropertySuffix();
         break;
      case 33:
         suffix = this.ArraySuffix();
         break;
      default:
         this.b[31] = this.v;
         this.a(-1);
         throw new ParseException();
      }

      return (ValueSuffix)suffix;
   }

   public final PropertySuffix PropertySuffix() throws ParseException {
      this.a(16);
      String property = this.Identifier();
      return new PropertySuffix(property);
   }

   public final ArraySuffix ArraySuffix() throws ParseException {
      this.a(33);
      Expression index = this.Expression();
      this.a(34);
      return new ArraySuffix(index);
   }

   public final Literal Literal() throws ParseException {
      Object ret;
      switch(this.t == -1?this.a():this.t) {
      case 7:
         ret = this.IntegerLiteral();
         break;
      case 8:
         ret = this.FloatingPointLiteral();
         break;
      case 9:
      case 11:
      default:
         this.b[32] = this.v;
         this.a(-1);
         throw new ParseException();
      case 10:
         ret = this.StringLiteral();
         break;
      case 12:
      case 13:
         ret = this.BooleanLiteral();
         break;
      case 14:
         ret = this.NullLiteral();
      }

      return (Literal)ret;
   }

   public final BooleanLiteral BooleanLiteral() throws ParseException {
      switch(this.t == -1?this.a():this.t) {
      case 12:
         this.a(12);
         return BooleanLiteral.TRUE;
      case 13:
         this.a(13);
         return BooleanLiteral.FALSE;
      default:
         this.b[33] = this.v;
         this.a(-1);
         throw new ParseException();
      }
   }

   public final StringLiteral StringLiteral() throws ParseException {
      return StringLiteral.fromToken(this.a(10).image);
   }

   public final IntegerLiteral IntegerLiteral() throws ParseException {
      Token t = this.a(7);
      return new IntegerLiteral(t.image);
   }

   public final FloatingPointLiteral FloatingPointLiteral() throws ParseException {
      Token t = this.a(8);
      return new FloatingPointLiteral(t.image);
   }

   public final NullLiteral NullLiteral() throws ParseException {
      this.a(14);
      return NullLiteral.SINGLETON;
   }

   public final String Identifier() throws ParseException {
      return this.a(49).image;
   }

   public final String QualifiedName() throws ParseException {
      String prefix = null;
      int var4 = Integer.MAX_VALUE;
      this.u = Integer.MAX_VALUE;
      this.b = this.a = this.token;
      boolean var5 = !this.c();
      this.b(1, Integer.MAX_VALUE);
      if(var5) {
         prefix = this.Identifier();
         this.a(32);
      }

      String localPart = this.Identifier();
      return prefix == null?localPart:prefix + ":" + localPart;
   }

   private final boolean b() {
      return this.e()?true:(this.u == 0 && this.a == this.b?false:(this.a(32)?true:(this.u == 0 && this.a == this.b?false:false)));
   }

   private final boolean c() {
      return this.e()?true:(this.u == 0 && this.a == this.b?false:(this.a(32)?true:(this.u == 0 && this.a == this.b?false:false)));
   }

   private final boolean d() {
      return this.f()?true:(this.u == 0 && this.a == this.b?false:(this.a(29)?true:(this.u == 0 && this.a == this.b?false:false)));
   }

   private final boolean e() {
      return this.a(49)?true:(this.u == 0 && this.a == this.b?false:false);
   }

   private final boolean f() {
      Token xsp = this.a;
      if(this.b()) {
         this.a = xsp;
      } else if(this.u == 0 && this.a == this.b) {
         return false;
      }

      return this.e()?true:(this.u == 0 && this.a == this.b?false:false);
   }

   public ELParser(InputStream stream) {
      this.a = new SimpleCharStream(stream, 1, 1);
      this.token_source = new ELParserTokenManager(this.a);
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   public void ReInit(InputStream stream) {
      this.a.ReInit((InputStream)stream, 1, 1);
      this.token_source.ReInit(this.a);
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   public ELParser(Reader stream) {
      this.a = new SimpleCharStream(stream, 1, 1);
      this.token_source = new ELParserTokenManager(this.a);
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   public void ReInit(Reader stream) {
      this.a.ReInit((Reader)stream, 1, 1);
      this.token_source.ReInit(this.a);
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   public ELParser(ELParserTokenManager tm) {
      this.token_source = tm;
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   public void ReInit(ELParserTokenManager tm) {
      this.token_source = tm;
      this.token = new Token();
      this.t = -1;
      this.v = 0;

      int i;
      for(i = 0; i < 34; ++i) {
         this.b[i] = -1;
      }

      for(i = 0; i < 2; ++i) {
         this.a[i] = new ELParser.a();
      }

   }

   private final Token a(int kind) throws ParseException {
      Token oldToken = this.token;
      if(this.token.next != null) {
         this.token = this.token.next;
      } else {
         this.token = this.token.next = this.token_source.getNextToken();
      }

      this.t = -1;
      if(this.token.kind != kind) {
         this.token = oldToken;
         this.x = kind;
         throw this.generateParseException();
      } else {
         ++this.v;
         if(++this.w > 100) {
            this.w = 0;

            for(int i = 0; i < 2; ++i) {
               for(ELParser.a c = this.a[i]; c != null; c = c.a) {
                  if(c.z < this.v) {
                     c.c = null;
                  }
               }
            }
         }

         return this.token;
      }
   }

   private final boolean a(int kind) {
      if(this.a == this.b) {
         --this.u;
         if(this.a.next == null) {
            this.b = this.a = this.a.next = this.token_source.getNextToken();
         } else {
            this.b = this.a = this.a.next;
         }
      } else {
         this.a = this.a.next;
      }

      if(this.g) {
         int i = 0;

         Token tok;
         for(tok = this.token; tok != null && tok != this.a; tok = tok.next) {
            ++i;
         }

         if(tok != null) {
            this.a(kind, i);
         }
      }

      return this.a.kind != kind;
   }

   public final Token getNextToken() {
      if(this.token.next != null) {
         this.token = this.token.next;
      } else {
         this.token = this.token.next = this.token_source.getNextToken();
      }

      this.t = -1;
      ++this.v;
      return this.token;
   }

   public final Token getToken(int index) {
      Token t = this.lookingAhead?this.a:this.token;

      for(int i = 0; i < index; ++i) {
         if(t.next != null) {
            t = t.next;
         } else {
            t = t.next = this.token_source.getNextToken();
         }
      }

      return t;
   }

   private final int a() {
      return (this.jj_nt = this.token.next) == null?(this.t = (this.token.next = this.token_source.getNextToken()).kind):(this.t = this.jj_nt.kind);
   }

   private void a(int kind, int pos) {
      if(pos < 100) {
         if(pos == this.y + 1) {
            ++this.y;
            this.f[this.y] = kind;
         } else {
            if(this.y != 0) {
               this.e = new int[this.y];

               for(int exists = 0; exists < this.y; ++exists) {
                  this.e[exists] = this.f[exists];
               }

               boolean var7 = false;
               Enumeration enum_ = this.a.elements();

               while(enum_.hasMoreElements()) {
                  int[] oldentry;
                  if((oldentry = (int[])enum_.nextElement()).length == this.e.length) {
                     var7 = true;

                     for(int i = 0; i < this.e.length; ++i) {
                        if(oldentry[i] != this.e[i]) {
                           var7 = false;
                           break;
                        }
                     }

                     if(var7) {
                        break;
                     }
                  }
               }

               if(!var7) {
                  this.a.addElement(this.e);
               }

               if(pos != 0) {
                  this.f[(this.y = pos) - 1] = kind;
               }
            }

         }
      }
   }

   public final ParseException generateParseException() {
      this.a.removeAllElements();
      boolean[] la1tokens = new boolean[54];

      int exptokseq;
      for(exptokseq = 0; exptokseq < 54; ++exptokseq) {
         la1tokens[exptokseq] = false;
      }

      if(this.x >= 0) {
         la1tokens[this.x] = true;
         this.x = -1;
      }

      int i;
      for(exptokseq = 0; exptokseq < 34; ++exptokseq) {
         if(this.b[exptokseq] == this.v) {
            for(i = 0; i < 32; ++i) {
               if((this.c[exptokseq] & 1 << i) != 0) {
                  la1tokens[i] = true;
               }

               if((this.d[exptokseq] & 1 << i) != 0) {
                  la1tokens[i + 32] = true;
               }
            }
         }
      }

      for(exptokseq = 0; exptokseq < 54; ++exptokseq) {
         if(la1tokens[exptokseq]) {
            this.e = new int[1];
            this.e[0] = exptokseq;
            this.a.addElement(this.e);
         }
      }

      this.y = 0;
      ELParser var4 = this;
      this.g = true;

      for(int var5 = 0; var5 < 2; ++var5) {
         ELParser.a var6 = var4.a[var5];

         do {
            if(var6.z > var4.v) {
               var4.u = var6.A;
               var4.b = var4.a = var6.c;
               switch(var5) {
               case 0:
                  var4.d();
                  break;
               case 1:
                  var4.c();
               }
            }
         } while((var6 = var6.a) != null);
      }

      var4.g = false;
      this.a(0, 0);
      int[][] var7 = new int[this.a.size()][];

      for(i = 0; i < this.a.size(); ++i) {
         var7[i] = (int[])this.a.elementAt(i);
      }

      return new ParseException(this.token, var7, tokenImage);
   }

   public final void enable_tracing() {
   }

   public final void disable_tracing() {
   }

   private final void b(int index, int xla) {
      ELParser.a p;
      for(p = this.a[index]; p.z > this.v; p = p.a) {
         if(p.a == null) {
            p = p.a = new ELParser.a();
            break;
         }
      }

      p.z = this.v + xla - this.u;
      p.c = this.token;
      p.A = xla;
   }

   static final class a {

      int z;
      Token c;
      int A;
      ELParser.a a;


   }
}
